'use strict';

var St = require('crypto');
var We = require('fs');
var path = require('path');
var promises = require('fs/promises');
var buffer = require('buffer');
var Fi = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var St__default = /*#__PURE__*/_interopDefault(St);
var We__default = /*#__PURE__*/_interopDefault(We);
var Fi__default = /*#__PURE__*/_interopDefault(Fi);

function Ar(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function X(){let e=Ar();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function vr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Cr(){return vr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function j(e=Cr()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function Er(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Ke(e){if(e===!1)return ee;if(typeof e=="number")return e;if(typeof e=="string"){let t=_t[e.toLocaleLowerCase().trim()];if(t!=null)return t}return W}function z(e=Er()){let t=Ke(e);return n=>n>=t}function we(e={}){let{level:t=void 0,filter:n=void 0}=e,r=j(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${a}`,...i.messages);break;case B:console.warn(`W|**  ${a}`,...i.messages);break;case $:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var W=-1,J=0,O=1,B=2,$=3,Te=4,ee=9007199254740991,_t={"*":W,a:W,all:W,d:J,dbg:J,debug:J,i:O,inf:O,info:O,w:B,warn:B,warning:B,e:$,err:$,error:$,fatal:Te,off:ee,"-":ee};function jt(e=""){let t=[we()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let p=Ke(c??W);function l(g,m){return p<=g?m:()=>{}}let f=l(J,(...g)=>{d({name:u,messages:g,level:J});});f.label=u,f.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return f.debug=l(J,(...g)=>{d({name:u,messages:g,level:J});}),f.info=l(O,(...g)=>{d({name:u,messages:g,level:O});}),f.warn=l(B,(...g)=>{d({name:u,messages:g,level:B});}),f.error=l($,(...g)=>{d({name:u,messages:g,level:$});}),f.fatal=l(Te,(...g)=>{throw d({name:u,messages:g,level:Te}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(Te,(g,...m)=>{(g==null||typeof g=="number"&&isNaN(g)||!g)&&f.fatal(...m);}),f}function s(u="",c){let p=o(u,c);return i&&p.debug(`+++ init of logger "${u}" on level "${p.level}".`),p}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=j(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=W,s.setLogLevel=function(u=W){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var V;function Ye(e){let t=jt();return e?e(t):t.setHandlers([we()]),t}function Qe(e){if(V==null)try{let t=X();t!=null?t?.logger==null?(V=Ye(e),t.logger=V):V=t.logger:V=Ye(e);}catch{V=Ye(e);}return V}function Nt(){if(V!=null)return V;try{let e=X();if(e?.logger!=null)return e.logger}catch{}}function R(e,t){return Qe()(e,t)}function Ur(...e){throw Nt()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Fr(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&Ur(...t);}function Vt(e,...t){Fr(e,...t);}var Dr=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function Ji(e,t=void 0){return JSON.stringify(e,Dr,t)}function Pr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function M(e,t,n,r){return JSON.stringify(e,Pr(t??void 0,r),n??void 0)}var Zi=M;function Sr(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Rr(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var Le;function Ht(e){if(Le==null&&(Le=Sr,typeof TextEncoder<"u")){let t=new TextEncoder;Le=n=>t.encode(n);}return Le(e.normalize("NFC"))}var Ae;function Gt(e){if(Ae==null&&(Ae=Rr,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Ae=n=>t.decode(n);}return Ae(e).normalize("NFC")}function E(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Ht(e):e.length?new Uint8Array(e):e}function Qi(...e){let t=0,n=e.flat(1).map(i=>{let a=E(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function zt(e){if(typeof Buffer<"u")return Buffer.from(E(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...E(e)])n+=t[r>>4]+t[r&15];return n}function Wt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function fe(e,t=!1){let n=E(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function Xi(e){let t=E(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function ve(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function es(e){return Gt(ve(e))}function qt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=E(e),r=E(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Xe(e){return Ht(M(e))}function et(e){return JSON.parse(Gt(e))}function Jt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let p=c.charCodeAt(0);return ` ${r[(240&p)>>4]}${r[15&p]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}var te;function Kt(){return te===void 0&&(te=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,te&&te.decode(new Uint8Array).length===1&&(te=null)),te}var Qt="Unexpected end of array",Xt="Integer out of Range",tt=class{constructor(t){this.arr=t,this.pos=0;}};function Fe(e){return new tt(e)}function nt(e,t){let n=ge(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function ne(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(Xt)}throw new Error(Qt)}function De(e){return nt(e,ne(e))}function de(e){return e.arr[e.pos++]}function en(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function tn(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function rt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(Xt)}throw new Error(Qt)}function Ir(e){let t=ne(e);if(t===0)return "";{let n=String.fromCodePoint(de(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(de(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function Ue(e){let t=Kt();return t?t.decode(De(e)):Ir(e)}function ot(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function it(e){return ot(e,4).getFloat32(0,!1)}function Br(e){return ot(e,8).getFloat64(0,!1)}function $r(e){return ot(e,8).getBigInt64(0,!1)}var Or=[e=>{},e=>null,rt,it,Br,$r,e=>!1,e=>!0,Ue,e=>{let t=ne(e),n={};for(let r=0;r<t;r++){let o=Ue(e);n[o]=re(e);}return n},e=>{let t=ne(e),n=[];for(let r=0;r<t;r++)n.push(re(e));return n},De];function re(e){return Or[127-de(e)](e)}function ge(e,t,n){return new Uint8Array(e,t,n)}var st=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function Re(){return new st}function at(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function Me(e){let t=new Uint8Array(at(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(ge(e.cbuf.buffer,0,e.cpos),n),t}function _r(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(ge(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function F(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var on=F;function sn(e,t){F(e,t&255),F(e,t>>>8&255);}function an(e,t){for(let n=0;n<4;n++)F(e,t&255),t>>>=8;}function Z(e,t){for(;t>127;)F(e,128|127&t),t=Math.floor(t/128);F(e,127&t);}function jr(e){return e!==0?e<0:1/e<0}function ut(e,t){let n=jr(t);for(n&&(t=-t),F(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)F(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function ke(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function Ie(e,t){Z(e,t.byteLength),ke(e,t);}function Vr(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;Z(e,r);for(let o=0;o<r;o++)F(e,n.codePointAt(o));}function Se(e,t){return Vr(e,t)}function ct(e,t){_r(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function lt(e,t){return ct(e,4).setFloat32(0,t,!1)}function Hr(e,t){return ct(e,8).setFloat64(0,t,!1)}function Gr(e,t){return ct(e,8).setBigInt64(0,t,!1)}var Pe;function zr(e){return Pe==null&&(Pe=new DataView(new ArrayBuffer(4))),Pe.setFloat32(0,e),Pe.getFloat32(0)===e}function ie(e,t){switch(typeof t){case"string":F(e,119),Se(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(F(e,125),ut(e,t)):zr(t)?(F(e,124),lt(e,t)):(F(e,123),Hr(e,t));break;case"bigint":F(e,122),Gr(e,t);break;case"object":if(t===null)F(e,126);else if(Array.isArray(t)){F(e,117),Z(e,t.length);for(let n=0;n<t.length;n++)ie(e,t[n]);}else if(t instanceof Uint8Array)F(e,116),Ie(e,t);else {F(e,118);let n=Object.keys(t);Z(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];Se(e,o),ie(e,t[o]);}}break;case"boolean":F(e,t?120:121);break;default:F(e,127);}}var un=class{async encode(t){let n=Re();return ie(n,t),Me(n)}async decode(t){return re(Fe(E(t)))}};function hs(e){let t=Re();return ie(t,e),Me(t)}function xs(e){return re(Fe(E(e)))}function bs(e){let t=Re();return e!=null&&ke(t,E(e)),{writeBytes:(n,r)=>{let o=E(n);Vt(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),ke(t,o);},writeBytesVar:n=>Ie(t,E(n)),writeUintVar:n=>Z(t,n),writeUint8:n=>on(t,n),writeUint16:n=>sn(t,n),writeUint32:n=>an(t,n),writeIntVar:n=>ut(t,n),writeFloat:n=>lt(t,n),writeStringVar:n=>Se(t,n),write:n=>ie(t,n),getUint8Array:()=>Me(t),getLength:()=>at(t)}}function ws(e){let t=Fe(E(e));return {readBytes:n=>nt(t,n),readBytesVar:()=>De(t),readUintVar:()=>ne(t),readUint8:()=>de(t),readUint16:()=>en(t),readUint32:()=>tn(t),readIntVar:()=>rt(t),readFloat:()=>it(t),readStringVar:()=>Ue(t),read:()=>re(t),getOffset:()=>t.pos||0}}function Ts(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function Wr(e){return await e.arrayBuffer()}async function Ls(e){let t=await Wr(e);if(t!=null)return E(t)}function se(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var ln="SHA-256",ft="AES-GCM",cn="PBKDF2",qr=1e5;async function Cs(e,t=ln){return E(await crypto.subtle.digest(t,E(e)))}async function Es(e,t={}){let n=E(e),r=await crypto.subtle.importKey("raw",n,cn,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:cn,salt:t.salt?E(t.salt):new Uint8Array(0),iterations:t.iterations??qr,hash:ln},r,{name:ft,length:256},!0,["encrypt","decrypt"])}function fn(){return new Uint8Array([1,1])}async function pn(e,t){let n=fn(),r=se(12),o=await crypto.subtle.encrypt({name:ft,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function dn(e,t){let n=e.subarray(0,2);if(!qt(n,fn()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:ft,iv:r},t,o);return new Uint8Array(i)}function Jr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function P(){return typeof crypto<"u"?Jr():Math.random()}function Fs(e=.25){return P()<e}function Ds(e=100,t=0){return t+Math.floor(P()*(e-t))}function Ps(e=100,t=0){return t+P()*(e-t)}function Ss(e,t,n){return Math.max(e,Math.min(n,t))}function Zr(e){return e.reduce((t,n)=>t+n,0)}function Rs(e){return Zr(e)/e.length}function Ms(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function ks(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var pt=6;function Is(e=0,t=1,n){pt=((n??pt)*9301+49297)%233280;let r=pt/233280;return t+r*(e-t)}function Kr(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function $s(e,t=!0){return `${e} ${t?"asc":"desc"}`}function dt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Os(e,...t){if(t.length>0){let n=t.map(Kr),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=dt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function gt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Yr(e,t){return gt(e.filter(n=>!t.includes(n)))}function Qr(...e){return gt(e.reduce((t=[],n)=>t.concat(n),[]))}function ae(...e){return e.flat(1/0)}function Xr(e,t){return gt(e).filter(n=>t.includes(n))}function Vs(e,t){return Yr(Qr(e,t),Xr(e,t))}function gn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function Hs(e,t){return e.includes(t)||e.push(t),e}function mt(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Gs(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function zs(e){return e.splice(0,e.length),e}function eo(e,t=dt){return Array.from(e).sort(t)}function Ws(e){return eo(e,(t,n)=>t-n)}function to(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function mn(e){return e.sort(()=>P()>.5?1:-1),e}function qs(e){return mn(Array.from(e))}function Js(e){for(;e.length>1;){let t=Array.from(e);if(mn(t),!to(e,t))return t}return e}function Zs(e){return e[Math.floor(P()*e.length)]}function Ks(...e){return ae(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Ys(...e){return ae(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function Qs(...e){return ae(e).reduce((t,n)=>t+n,0)}function Xs(...e){let t=ae(e);return t.reduce((n,r)=>n+r,0)/t.length}function ea(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function ta(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var no={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function ro(e){let t=no[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let p=t.charAt(c),l=p.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${p} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,p=-1){let l=E(c);if(l.byteLength===0)return "";let f=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,b=new Uint8Array(m);for(;d!==g;){let v=l[d],U=0;for(let h=m-1;(v!==0||U<f)&&h!==-1;h--,U++)v+=256*b[h]>>>0,b[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");f=U,d++;}let y=m-f;for(;y!==m&&b[y]===0;)y++;let T="";for(;y<m;++y)T+=t.charAt(b[y]);return p>0?T.padStart(p,o):T}function u(c,p=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let T=d-1;(b!==0||y<f)&&T!==-1;T--,y++)b+=r*g[T]>>>0,g[T]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=y,l++;}let m=d-f;for(;m!==d&&g[m]===0;)m++;return p>0?new Uint8Array([...new Uint8Array(p-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Be;function q(e){Be==null&&(Be=new Map);function t(){let o=Be.get(e);return o==null&&(o=ro(e),Be.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function yt(e,t=-1){return q(32).encode(e,t)}function yn(e,t=-1){return q(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function oa(e,t=-1){return q(16).encode(e,t)}function ia(e,t=-1){return q(16).decode(e,t)}function sa(e,t=-1){return q(58).encode(e,t)}function aa(e,t=-1){return q(58).decode(e,t)}function ht(e,t=-1){return q(62).encode(e,t)}function hn(e,t=-1){return q(62).decode(e,t)}function ua(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}function xn(e){return e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e}function oo(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function la(e){return e.replace(/\w\S*/g,oo)}function fa(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var bn=["1","true","yes","y","on"];function ga(e,t=!1){return e==null||typeof e!="string"?t:bn.includes(String(e).trim().toLowerCase())}function ma(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function ya(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function ue(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:bn.includes(String(e).trim().toLowerCase())}function io(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function so(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function xt(e,t=""){return e==null?t:String(e)??t}var ha=so,xa=io,ba=xt,wa=ue;function ao(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${Jt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function $e(e,t={}){return ao(e,t).join(" ")}function Ta(e){try{return decodeURIComponent(escape(e))}catch{}return e}function va(e){if(e.startsWith("data:"))return ve(e.split(",",2)[1])}function Ca(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function Ea(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([ve(n)],{type:t})}}async function Ua(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${fe(t)}`}function Fa(e,t="application/octet-stream"){return `data:${t},${fe(e)}`}var wn=864e5;function wt(e){return Math.floor(e/1e4)}function Tn(e){return Math.floor(e/100%100)}function uo(e){return Math.floor(e%100)}function Pa(e){return [wt(e),Tn(e),uo(e)]}function Ln(e,t=!1){return t?new Date(`${lo(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function An(){return _e(new Date)}function Sa(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return vn(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Tt(n,r,o)}else if(e instanceof Date)return _e(e,t)}function Ra(e){return Ln(e,!0)}function _e(e,t=!1){return t?vn(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Ma(e){return _e(e,!0)}function bt(e,t=!0){return Ln(e,t).getTime()}function co(e,t=!0){return _e(new Date(e),t)}function lo(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Tt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function vn(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function ka(e,t=0){let n=wt(e),r=Tn(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Tt(n,r,1)}function Ia(e,t=0){let n=wt(e);return Tt(n+t,1,1)}function Oe(e,t){return co(bt(e)+t*864e5)}function Ba(e,t){return Math.round((bt(t)-bt(e))/864e5)}function $a(e,t){let n=[];for(t==null&&(t=An()),e<0&&(e=Oe(t,e+1));e<=t;)n.push(e),e=Oe(e,1);return n}function*Oa(e,t){let n=[];for(t==null&&(t=An()),e<0&&(e=Oe(t,e+1));e<=t;)yield e,e=Oe(e,1);return n}function Cn(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function ja(e){return new Promise(t=>setTimeout(t,e))}async function Na(){return new Promise(e=>setTimeout(e,0))}async function Va(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function Ha(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function En(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function Ga(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function k(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function H(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function qa(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);k(i)&&await i,r=r.dayOffset(1);}}function Ja(){return new A}function Za(e){return new A(e)}function Ka(e){return A.fromDate(new Date(e)).days}function fo(e,t=2){return +(+e).toFixed(t)}function Qa(e,t=2){return +(+e/10**t).toFixed(t)}function Xa(e,t=2){return Math.round(+e*10**t)}function eu(e,t=2){return t*(fo(e,t)%1)}function ru(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function ou(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Un(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function iu(e){return e!=null&&e.length>0?e[0]:void 0}function su(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function au(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function ce(e){return Object(e)!==e?e:JSON.parse(M(e))}function uu(e){return Object(e)!==e?e:JSON.parse(M(e))}function cu(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function lu(e){let t=new Map;return async(...n)=>{let r=M(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function fu(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}function N(e){return e!=null&&typeof e=="object"}function Lt(e){return Object(e)!==e}function G(e){return Array.isArray(e)}function je(e){return N(e)&&!G(e)}function gu(e){return e?.constructor===Object}function Fn(e){return typeof e=="string"}function Dn(e){return typeof e=="number"&&!isNaN(e)}function mu(e){return Dn(e)&&Number.isInteger(e)}function yu(e){return Dn(e)&&Number.isSafeInteger(e)}function Pn(e){return typeof e=="boolean"}function hu(e){return e==null}function xu(e){return e==null}function bu(e){return N(e)&&e.constructor.name==="Uint8Array"}function Sn(e){return e!=null}function po(e){return e==null||e===""||N(e)&&Un(e)<=0}function wu(e){return !po(e)}function Tu(e){return e!=null&&e!==!1&&e!==!0}function Lu(e){return e!=null&&e!==!1&&e!==0&&e!==""}function go(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Lt(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!go(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function mo(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Lt(e)||t.add(e),je(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}mo(e[n],t);}}else if(G(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function Ne(e,...t){for(let n of t)N(e)||(e={}),!(n==null||!N(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):N(o)&&N(i)?e[r]=Ne(Object.assign({},o),i):e[r]=i;});return e}function yo(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let p=t[s],l=typeof u=="object"&&typeof p=="object";if(u&&p&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let f=yo(u,p,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...f.map(d=>(d.path.unshift(c),d))];}else u!==p&&!(l&&(isNaN(u)?`${u}`==`${p}`:+u==+p))&&o.push({path:[c],type:"upd",value:p});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}function Rn(e){return e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;")}function Uu(e){return e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&")}function Du(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Pu(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Su(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Ru(e,t){return e.map(n=>n[t])}function Iu(e,t){return N(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return G(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function Bu(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function $u(e){return Object.keys(e).length<=0}var ho=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ve(e){return e?e instanceof RegExp?e.source:e.replace(ho,"\\$&"):""}var xo=100,bo=/^\.+/,wo=/\.+$/,To=/[<>:\"/\\|?*\u0000-\u001F\u0080-\u009F]+/gm;function Mn(){return To}function Lo(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function kn(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(Mn().test(t))throw new Error("Replacement string cannot contain reserved filename characters");let n=`(${Ve(t)})+`;return e=e.replace(Mn(),t).replace(bo,t).replace(wo,"").replace(new RegExp(n,"gm"),t).trim(),e=Lo().test(e)?e+t:e,e.slice(0,xo)}function ye(e){return Math.abs(e)%1===.5}function In(e){return e%2===0}var Vu=e=>Math.ceil(e),Hu=e=>Math.floor(e),Gu=e=>Math.round(e),zu=e=>{let t=Math.round(e);return ye(e)&&In(t)?t-1:t},Wu=e=>ye(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),qu=e=>ye(e)?Math.floor(e):Math.round(e),Ju=e=>{let t=Math.round(e);return ye(e)?In(t)?t:t-1:t},Zu=e=>ye(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function Bn(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-P()}function $n(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+P()}function Qu(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return $n(n);if(e<=0)return Bn(n);n=Ao([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?Bn(n):$n(n);let c=a+u/2,p=u*.01*(P()-.5);return c+p}function Ao(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function tc(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-P()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+P()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,p=s+c/2,l=c*.01*(P()-.5);return p+l}function a(s,u,c){let p=c.length,l=s<u;if(p<=0||s>=p-1)return o(c);if(s<=0)return r(c);c=n([...c]);let f=l?-1:0,d=t(c[s+f])||0,m=(t(c[s+f+1])||0)-d;if(m===0)return l?r(c):o(c);let b=d+m/2,y=m*.01*(P()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var vo=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function oc(e){return e.split(vo).map((t,n)=>{let r=Rn(t);return n%2?`<a target="_blank" href="${r}">${Co(r)}</a>`:r}).join("")}function Co(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function On(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function ic(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}var Eo=/\\\s|\s+|#[^\n]*\n?/gm,Uo=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,_n=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Fo(e){return typeof e=="string"?e:e.source||""}function ac(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var jn=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(Eo,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(Uo,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Fo(o),_n.lastIndex=0;let a=_n.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Do=",";function lc(e,t={}){let{separator:n=Do}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Pn(i))return i?1:0;let a=String(i);return (je(i)||G(i))&&(a=M(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function Po(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ve(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function fc(e,t={}){let n=Po(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}async function So(e){typeof e=="function"?await H(e()):k(e)?await e:typeof e.dispose=="function"?await H(e.dispose()):k(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await H(e.cleanup()):k(e.cleanup)&&await e.cleanup;}function he(e){let t=e;t!=null&&(Fn(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??R("zeed:dispose"),o=[],i=async u=>{u!=null&&o.includes(u)&&(mt(o,c=>c!==u),await So(u));},a=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},s=u=>{if(u!=null)return o.unshift(u),()=>i(u)};return Object.assign(a,{track:s,add:s,untrack:i,dispose:a,exec:a,getSize(){return o.length},isDisposed(){return o.length<=0}})}var hc=he;function xc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(mt(n,s=>s!==a),typeof a=="function"){let s=a();if(k(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(k(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function bc(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function wc(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function Tc(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function vc(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function Cc(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();k(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();k(o)&&await o;}return r}}var I=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=R("zeed:emitter","error");this.dispose=he();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return H(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await H(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Rc(){let e=X().emitter;return e||(e=new I,X().emitter=e),e}function Mc(e,t){let n=Math.round(P()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,p)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;p(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}function K(){return Date.now()}function At(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Ic(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}function Nn(){return typeof performance<"u"?performance.now():Date.now()}function Bc(){let e=Nn();return function(){let t=Nn()-e;return At(t)}}var He=16;function Ct(){return se(He)}function Ro(e=Ct()){return ht(e,22)}function Mo(e){return ht(e,22)}function ko(e){return hn(e,He)}function Io(e=Ct()){return yt(e,26)}function Bo(e){return yt(e,26)}function $o(e){return yn(e,He)}var Oo="10000000-1000-4000-8000-100000000000",_o=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():Oo.replace(/[018]/g,e=>(e^se(1)[0]&15>>e/4).toString(16))};function jo(e){let t=zt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function No(e){return Wt(e.replaceAll("-",""))}var Vn=16e11;function Vo(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Hn(){let e=K()-Vn;return new Uint8Array([...Vo(e),...se(10)])}function Vc(){return Go(Hn())}function Hc(e){return Ho(zn(e))}function Ho(e){return new Date(Vn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function Gc(){return new Uint32Array(se(4))[0]}var Et={base62:{uuid:Ro,uuidDecode:ko,uuidEncode:Mo},base32:{uuid:Io,uuidDecode:$o,uuidEncode:Bo},uuidv4:{uuid:_o,uuidDecode:No,uuidEncode:jo}},Ge="base62",Gn=!1;function zc(e,t=!1){Ge=e,Gn=t;}function Y(){return Et[Ge].uuid(Gn?Hn():Ct())}function zn(e){return Et[Ge].uuidDecode(e)}function Go(e){return Et[Ge].uuidEncode(e)}function Wc(e){try{return zn(e).length===He}catch{}return !1}var vt={};function _(e="id"){return vt[e]==null&&(vt[e]=0),`${e}-${vt[e]++}`}var zo=0;function qc(){return `id-${zo++}`}var Ut=class extends I{constructor(){super(...arguments);this.id=Y();}close(){this.dispose();}},ze=class extends Ut{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:Y()});}};function Yc(){let e=new ze,t=new ze;return e.other=t,t.other=e,[e,t]}var Wn=class{async encode(t){return t}async decode(t){return t}},le=class{async encode(t){return Xe(t)}async decode(t){return et(t)}},qn=class{constructor(t){this.key=t;}async encode(t){let n=Xe(t);return await pn(n,this.key)}async decode(t){let n=await dn(t,this.key);return et(n)}};function Jn(e,t,n={}){return new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)})}function al(e={}){let{name:t=_("hub"),encoder:n=new le,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=R(t,i),s={},u,c=[],p,l={},f=()=>{clearTimeout(p);},d=async()=>{if(clearTimeout(p),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(T){a.warn("postMessage",T);break}}c.length>0&&r>0&&(p=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async T=>{a("onmessage",typeof T);let{name:v,args:U,id:h,result:x,error:L}=await n.decode(T.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let C=s[v](...U);k(C)&&(C=await C),a(`result ${C}`),h&&await g({id:h,result:C});}catch(C){let w=C instanceof Error?C:new Error(xt(C));a.warn("execution error",w.name),await g({id:h,error:{message:w.message,stack:w.stack,name:w.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[C,w]=l[h];if(C&&w)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,a.warn("reject",D.name),w(D);}else a("resolve",x),C(x);}else o||a.warn("Unhandled message",T);}),await d();},b=async(y,T,v={})=>{let{timeout:U=5e3}=v,h=Y();return await g({name:y,args:T,id:h}),En(new Promise((x,L)=>l[h]=[x,L]),U)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(s,y);},send(){return Jn(b,{},{options(y){return Jn(b,{...y})}})}}}var Ft=class extends I{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new le,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??_("pubsub"),this.log=R(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:p}=u;await this.emitSuper(c,...p);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function dl(e){return new Ft(e)}var Zn=1;var Dt=e=>e,Kn=Dt;function ml(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Dt,deserialize:a=Kn}=t,s=new Map;return r(async u=>{let c=a(u),[p,l,f,d]=c;if(p===1||p===2){let g,m;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";p===1&&f&&n(i(m?[4,m,f]:[3,g,f]));}else if(f){let g=s.get(f);g!=null&&(p===4?g.reject(l):g.resolve(l)),s.delete(f);}}),new Proxy({},{get(u,c){let p=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return p.asEvent=p,p;let l=(...f)=>new Promise((d,g)=>{let m=Zn++;s.set(m,{resolve:d,reject:g}),n(i([1,f,m,c]));});return l.asEvent=p,l}})}function yl(e){let{post:t,on:n,serialize:r=Dt,deserialize:o=Kn}=e,i=[],a={},s=new Map;n(async c=>{let p=o(c),[l,f,d,g]=p;if(l===1||l===2){let m,b;if(g!=null)try{let y=a[g];m=await y(...f);}catch(y){b=String(y);}else b="Method implementation missing";l===1&&d&&t(r(b?[4,b,d]:[3,m,d]));}else if(d){let m=s.get(d);m!=null&&(l===4?m.reject(f):m.resolve(f)),s.delete(d);}});function u(){return new Proxy({},{get(c,p){let l=(...d)=>{t(r([2,d,null,p]));};if(e.onlyEvents||i.includes(p))return l.asEvent=l,l;let f=(...d)=>new Promise((g,m)=>{let b=Zn++;s.set(b,{resolve:g,reject:m}),t(r([1,d,b,p]));});return f.asEvent=l,f}})}return function(c,p=[]){return Object.assign(a,c??{}),i.push(...p),u()}}var Q=class extends I{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??_("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Q(n);return this.addChild(r),r}removeChild(n){gn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function Ul(e={}){let{maxParallel:t=3,name:n=_("pool"),idConflictResolution:r="memoize"}=e,o=new I,i=he();i.add(T);let a=new Q({name:n});a.on("progressCancelled",T);let s=0,u=0,c=0,p=0,l={};async function f(){if(s>0){let[h,x]=Cn();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:C,state:w}of Object.values(l))h+=L,x+=w==="finished"?L:Math.min(L,C);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(C=>C.state==="running"&&C.id!==L.id&&C.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,C=x.done;x.state="running",++c,o.emit("didStart",L);let w=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(D=>{C(D),o.emit("didResolve",L,D),w(D);}).catch(D=>{C(),o.emit("didReject",L,D),w();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function T(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function U(h,x={}){let L,C=new Promise(S=>L=S),w=x.id??Y();if(l[w]!=null){let S=x.idConflictResolution??r;if(S==="replace")y(w);else if(S==="memoize"||S==="prioritize"){let Ot=l[w];return S==="prioritize"&&(Ot.priority=++p),{id:w,promise:(async()=>{if(Ot.state==="finished")return l[w].result})(),dispose:()=>y(w),cancel:()=>y(w)}}else throw new Error(`Pool task with id=${w} already exists!`)}let D=new Q({name:w,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(D),l[w]={id:w,task:h,priority:++p,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(S){D.setTotalUnits(S),l[w].max=S,m();},setResolved(S){D.setCompletetedUnits(S),l[w].resolved=S,m();},incResolved(S=1){D.incCompletedUnits(S),l[w].resolved+=S,m();}},++s,b(),{id:w,promise:C,dispose:()=>y(w),cancel:()=>y(w)}}return {events:o,cancel:y,cancelAll:T,hasById:v,progress:a,enqueue:U,dispose:i,waitFinishAll:f}}var Yn=class extends I{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=_("queue"),logLevel:o}=n;this.name=r,this.log=R(`zeed:queue:${r}`,o??ee);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=_(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Il(e,t={}){let{delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function c(){return i?(clearTimeout(i),i=void 0,!0):!1}function p(...l){let f=Date.now(),d=f-a,g=()=>{s=0,a=Date.now(),e.apply(this,l);};if(u=g,d>n||!i){o&&(d>n?g():++s);let m=d>n?n:n-d;c(),a=f,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},m);}else ++s;}return p.cancel=c,p.stop=()=>{c()&&u&&u();},p.immediate=async function(...f){c(),a=Date.now(),e.apply(this,f);},p.dispose=()=>p.stop(),p}function Bl(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let p=[...i];i=void 0,o=!0,await H(e(...p)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...p){i=[...p],a(),o===!1&&(r=setTimeout(s,n));}async function c(...p){a(),i=[...p],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function Ol(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}var Qn=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function jl(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return Qn[Math.abs(t)%Qn.length]}function Gl(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=j(n),i=z(t);return a=>{i(a.level)&&o(a.name)&&(a.timestamp=K(),r.push(a));}}var Pt={cache:"no-cache",redirect:"follow",headers:{}};function Wo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function Xn(e,t={},n=fetch){try{G(t)&&(t=Ne({},...ae(t)));let r=Wo(String(e));r&&(e=r.url,t=Ne({},t,qo(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=R("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){R("zeed:network").error("fetchBasic",r);}}async function Zl(e,t={},n=fetch){try{let r=await Xn(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){R("zeed:network").error("fetchJSON error:",r);}}async function Kl(e,t={},n=fetch){try{let r=await Xn(e,[Pt,{method:"GET"},t],n);if(r)return await r.text()}catch(r){R("zeed:network").error("fetchHTML error:",r);}}function Yl(e,t="POST"){return {method:t,...Pt,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:On(e)}}function Ql(e,t="POST"){return {method:t,...Pt,headers:{"Content-Type":"application/json; charset=utf-8"},body:M(e)}}function qo(e,t){return {headers:{Authorization:`Basic ${fe(`${e}:${t}`)}`}}}function er(){if(typeof window<"u")return window}function Jo(){if(typeof navigator<"u")return navigator}function ef(){return er()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function tf(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Jo(),n=er();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Zo(){return typeof window<"u"&&globalThis===window}function nf(e){Zo()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var tr=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=ce(n);}getItem(t){return ce(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};function af(){}function lf(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=xn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((f,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let b of m)f[r(b)]=r(g);return f},{}),u={_:[]};function c(f,d){u[f]==null||typeof u[f]=="boolean"?u[f]=d:Array.isArray(u[f])?u[f].push(d):u[f]=[u[f],d];}let p=[...t],l;for(;l=p.shift();){let f;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),f=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(f=f??p.shift()??"",a.includes(d)&&(f=Number(f??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(f):u[d]=[f]:c(d,f));}else u._.push(l);}return u}function pf(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function mf(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&St__default.default&&St__default.default.webcrypto&&(globalThis.crypto=St__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function yf(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Yo=`
`,Qo=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Xo=/\\n/g,ei=/\n|\r|\r\n/;function nr(e,t={}){let n={};return String(e).split(ei).forEach((r,o)=>{let i=r.match(Qo);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(Xo,Yo))):s=s.trim(),n[a]=s;}}),n}function ti(e,t="."){return path.resolve(process.cwd(),e??t)}function ni(e,t=""){return e==null&&(e=t),ti(String(e).trim(),t)}var Rt=ni;function wf(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function Tf(e={}){let t=e?.path??Rt(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=We__default.default.existsSync(t)?nr(We__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=We__default.default.existsSync(`${t}.local`)?nr(We__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function Cf(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function kt(e){try{await promises.stat(e);}catch{return !1}return !0}function qe(e){return e.startsWith(".")||e.includes("/.")}async function Ef(...e){let t=path.join(...e);return await kt(t)||await promises.mkdir(t,{recursive:!0}),t}async function Uf(...e){let t=path.join(...e);return await kt(t)&&await promises.rm(t,{recursive:!0}),t}async function Ff(...e){let t=path.join(...e);if(await kt(t))return await promises.readFile(t,"utf-8")}async function Df(e,t){await promises.writeFile(e,t,"utf-8");}function Je(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,p=n.length;c<p;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],f=1;for(;n[c+1]==="*";)f++,c++;let d=n[c+1];i?f>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function or(e){try{return We.statSync(e)}catch{}}function Bf(e){let{mtimeMs:t,size:n}=or(e)??{};return `${e}|${t}|${n}`}function ir(e,t="",n=!0){let r=[],o=We.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=or(a);s&&s.isDirectory()?r=r.concat(ir(e,i)||[]):r.push(i);}return r}function $f(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=ir(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function ar(e){try{return await promises.stat(e)}catch{}}async function Hf(e){let{mtimeMs:t,size:n}=await ar(e)??{};return `${e}|${t}|${n}`}async function ur(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=await ar(a);s&&s.isDirectory()?r=r.concat(await ur(e,i)||[]):r.push(i);}return r}async function Gf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=await ur(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var fr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?M(n,null,2):M(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??kn;}setItem(t,n){this.store[t]=ce(n);try{let r=this.objectToString(n),o=this.getPath(t);We.mkdirSync(path.dirname(o),{recursive:!0}),We.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return buffer.Buffer.from(We.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return ce(n);try{let r=this.getPath(t),o=We.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);We.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},We.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=We.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var pr={};function dr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),We.mkdirSync(path.dirname(e),{recursive:!0});let a=We.createWriteStream(e,{flags:"a"}),s=j(r),u=z(n);return c=>{if(!u(c.level)||!s(c.name))return;let p=o?`${new Date().toISOString()} `:"",l=c.name||"",f=pr[l||""];f==null&&(pr[l]=f);let d=[`[${l||"*"}]`,$e(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case O:g(`${p}I|*  `,...d);break;case B:g(`${p}W|** `,...d);break;case $:g(`${p}E|***`,...d);break;default:g(`${p}D|   `,...d);break}}}function Ei(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Sn)??[]}function mr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Ui(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function It(e=2,t=!0){let n=new Error("stack").stack||"",r=Ei(n)?.[e];return r&&t&&(r=mr(r)),r||""}function yr(){return new Error("stack").stack||""}function hr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Ui(n)),n&&t&&(n=mr(n));}return n}function Di(){try{return ue(process.env.ZEED_COLOR,Fi__default.default.isatty(process.stdout.fd))}catch{}return !1}var Bt,xr=[6,2,3,4,5,1];function Pi(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return xr[Math.abs(t)%xr.length]}var br={},$t;function Ze(...e){process.stdout.write(`${$e(e)}
`);}var be={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var Tr="\x1B[0m";function xe(e,t){return `${t===8?be.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${Tr}`}function wr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=Tr;return n&&(o=`${be.BOLD}${o}`,i=`${i}${be.BOLD}`),`${o}${r}${i}`})}var Si="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function Lr(e={}){Bt==null&&(Bt=Di()),$t==null&&($t=K());let{level:t=void 0,filter:n=void 0,colors:r=Bt,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=!0,time:c=!0}=e,p=j(n),l=z(t);return f=>{if(!l(f.level)||!p(f.name))return;let d=K(),g=f.name||"",m=br[g||""];m==null&&(m={color:Pi(g)},br[g]=m);let b=At(d-$t),y,T=i?`[${g}]`:g;if(a>0&&(T=T.padStart(a," ")),s>0&&(T=T.padEnd(s," ")),r){let h=m.color;y=[`${xe(T,h)} | `],f.level===B?y.push(...wr(f.messages,be.ORANGE)):f.level===$?y.push(...wr(f.messages,be.RED)):y.push(...f.messages),c&&y.push(xe(`+${b}`,h));}else y=[T,...f.messages],c&&y.push(`+${b}`);if(f.messages?.[0]===Si&&console.log(yr()),u){let h="";typeof u=="boolean"?(h=hr(["at Function.","at null.log (","at log ("],!0),h||(h=It(0,!0))):h=It(typeof u=="number"?u:3,!0),h&&y.push(xe(`(${h})`,7));}let v="|",U=".";switch(f.level){case O:o&&(y[0]=`I${v}${U}   ${y[0]}`),Ze(...y);break;case B:o&&(y[0]=(r?xe(`W${v}${U}${U}  `,8):`W${v}${U}${U}  `)+y[0]),Ze(...y);break;case $:o&&(y[0]=(r?xe(`E${v}${U}${U}${U} `,1):`E${v}${U}${U}${U} `)+y[0]),Ze(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),Ze(...y);break}}}function Ri(e,t){return Qe(n=>{let r=[Lr({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=ue(process.env.ZEED_TIME,!0),a=ue(process.env.ZEED_PRETTY,!1);o&&r.unshift(dr(Rt(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = un;
exports.CRYPTO_DEFAULT_ALG = ft;
exports.CRYPTO_DEFAULT_DERIVE_ALG = cn;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = qr;
exports.CRYPTO_DEFAULT_HASH_ALG = ln;
exports.Channel = Ut;
exports.CryptoEncoder = qn;
exports.DAY_MS = wn;
exports.Day = A;
exports.DefaultLogger = R;
exports.Emitter = I;
exports.FileStorage = fr;
exports.JsonEncoder = le;
exports.LocalChannel = ze;
exports.LogLevelAlias = _t;
exports.LogLevelAll = W;
exports.LogLevelDebug = J;
exports.LogLevelError = $;
exports.LogLevelFatal = Te;
exports.LogLevelInfo = O;
exports.LogLevelOff = ee;
exports.LogLevelWarn = B;
exports.Logger = Ri;
exports.LoggerConsoleHandler = we;
exports.LoggerContext = jt;
exports.LoggerFileHandler = dr;
exports.LoggerMemoryHandler = Gl;
exports.LoggerNodeHandler = Lr;
exports.MemStorage = tr;
exports.NoopEncoder = Wn;
exports.Progress = Q;
exports.PubSub = Ft;
exports.SerialQueue = Yn;
exports.Uint8ArrayToDataUri = Fa;
exports.Uint8ArrayToHexDump = Jt;
exports.Uint8ArrayToJson = et;
exports.Uint8ArrayToString = Gt;
exports.XRX = jn;
exports._decodeUtf8Polyfill = Rr;
exports._encodeUtf8Polyfill = Sr;
exports._useBase = ro;
exports.arrayAvg = Xs;
exports.arrayBatches = ea;
exports.arrayEmptyInPlace = zs;
exports.arrayFilterInPlace = mt;
exports.arrayFlatten = ae;
exports.arrayIntersection = Xr;
exports.arrayIsEqual = to;
exports.arrayMax = Ks;
exports.arrayMin = Ys;
exports.arrayMinus = Yr;
exports.arrayRandomElement = Zs;
exports.arrayRemoveElement = gn;
exports.arraySetElement = Hs;
exports.arrayShuffle = qs;
exports.arrayShuffleForce = Js;
exports.arrayShuffleInPlace = mn;
exports.arraySorted = eo;
exports.arraySortedNumbers = Ws;
exports.arraySum = Qs;
exports.arraySymmetricDifference = Vs;
exports.arrayToggleInPlace = Gs;
exports.arrayUnion = Qr;
exports.arrayUnique = gt;
exports.assert = Fr;
exports.assertCondition = Vt;
exports.avg = Rs;
exports.between = Ss;
exports.bitfield = Ts;
exports.blobToArrayBuffer = Wr;
exports.blobToDataUri = Ua;
exports.blobToUint8Array = Ls;
exports.browserSelectColorByName = jl;
exports.cloneJsonObject = uu;
exports.cloneObject = ce;
exports.cmp = dt;
exports.colorString = xe;
exports.colorStringList = wr;
exports.composeOrderby = $s;
exports.createArray = ta;
exports.createBinaryStreamDecoder = ws;
exports.createBinaryStreamEncoder = bs;
exports.createLocalChannelPair = Yc;
exports.createPromise = Cn;
exports.createPromiseProxy = Jn;
exports.csvParse = Po;
exports.csvParseToObjects = fc;
exports.csvStringify = lc;
exports.dataUriToBlob = Ea;
exports.dataUriToMimeType = Ca;
exports.dataUriToUint8Array = va;
exports.dateStringToDays = Ka;
exports.day = Za;
exports.dayDay = uo;
exports.dayDiff = Ba;
exports.dayFromAny = Sa;
exports.dayFromDate = _e;
exports.dayFromDateGMT = Ma;
exports.dayFromParts = Tt;
exports.dayFromString = vn;
exports.dayFromTimestamp = co;
exports.dayFromToday = An;
exports.dayIterator = Oa;
exports.dayMonth = Tn;
exports.dayMonthStart = ka;
exports.dayOffset = Oe;
exports.dayRange = $a;
exports.dayToDate = Ln;
exports.dayToDateGMT = Ra;
exports.dayToParts = Pa;
exports.dayToString = lo;
exports.dayToTimestamp = bt;
exports.dayYear = wt;
exports.dayYearStart = Ia;
exports.debounce = Bl;
exports.decimal = fo;
exports.decimalCentsPart = eu;
exports.decimalFromCents = Qa;
exports.decimalToCents = Xa;
exports.decodeBase16 = ia;
exports.decodeBase32 = yn;
exports.decodeBase58 = aa;
exports.decodeBase62 = hn;
exports.decodeJson = xs;
exports.decrypt = dn;
exports.deepEqual = go;
exports.deepMerge = Ne;
exports.deepStripUndefinedInPlace = mo;
exports.deriveKeyPbkdf2 = Es;
exports.detect = tf;
exports.diffObjects = yo;
exports.digest = Cs;
exports.duration = Bc;
exports.empty = au;
exports.encodeBase16 = oa;
exports.encodeBase32 = yt;
exports.encodeBase58 = sa;
exports.encodeBase62 = ht;
exports.encodeJson = hs;
exports.encodeQuery = On;
exports.encrypt = pn;
exports.endSortWeight = $n;
exports.ensureFolder = Ef;
exports.ensureKey = ru;
exports.ensureKeyAsync = ou;
exports.equalBinary = qt;
exports.escapeHTML = Rn;
exports.escapeRegExp = Ve;
exports.estimateSizeForBase = ua;
exports.exists = kt;
exports.fatal = Ur;
exports.fetchBasic = Xn;
exports.fetchJson = Zl;
exports.fetchOptionsBasicAuth = qo;
exports.fetchOptionsFormURLEncoded = Yl;
exports.fetchOptionsJson = Ql;
exports.fetchText = Kl;
exports.files = $f;
exports.filesAsync = Gf;
exports.first = iu;
exports.fixBrokenUth8String = Ta;
exports.forEachDay = qa;
exports.forTimes = fu;
exports.formatMessages = ao;
exports.formatMilliseconds = At;
exports.fromBase64 = ve;
exports.fromBase64String = es;
exports.fromCamelCase = fa;
exports.fromHex = Wt;
exports.getEnvVariableRelaxed = wf;
exports.getFingerprint = Bf;
exports.getFingerprintAsync = Hf;
exports.getGlobal = ef;
exports.getGlobalContext = X;
exports.getGlobalEmitter = Rc;
exports.getGlobalLogger = Qe;
exports.getGlobalLoggerIfExists = Nt;
exports.getNamespaceFilterString = vr;
exports.getNavigator = Jo;
exports.getPerformanceTimestamp = Nn;
exports.getSecureRandom = Jr;
exports.getSecureRandomIfPossible = P;
exports.getSourceLocation = It;
exports.getSourceLocationByPrecedingPattern = hr;
exports.getStack = yr;
exports.getStackLlocationList = Ei;
exports.getStat = or;
exports.getStatAsync = ar;
exports.getTimestamp = K;
exports.getWebCrypto = yf;
exports.getWindow = er;
exports.globToRegExp = Je;
exports.immediate = Na;
exports.isArray = G;
exports.isBoolean = Pn;
exports.isBrowser = Zo;
exports.isEmpty = po;
exports.isEven = In;
exports.isHalf = ye;
exports.isHiddenPath = qe;
exports.isInteger = mu;
exports.isLocalHost = Ol;
exports.isNotEmpty = wu;
exports.isNotNull = Sn;
exports.isNull = xu;
exports.isNullOrUndefined = hu;
exports.isNumber = Dn;
exports.isObject = N;
exports.isPrime = ks;
exports.isPrimeRX = Ms;
exports.isPrimitive = Lt;
exports.isPromise = k;
exports.isRecord = je;
exports.isRecordPlain = gu;
exports.isSafeInteger = yu;
exports.isString = Fn;
exports.isTimeout = Ha;
exports.isTruthy = Lu;
exports.isUint8Array = bu;
exports.isValue = Tu;
exports.joinToUint8Array = Qi;
exports.jsonStringify = Zi;
exports.jsonStringifySafe = M;
exports.jsonStringifySorted = Ji;
exports.jsonToUint8Array = Xe;
exports.last = su;
exports.lazyListener = Mc;
exports.linkifyPlainText = oc;
exports.listDistinctUnion = Su;
exports.listGroupBy = Pu;
exports.listOfKey = Ru;
exports.listQuery = Du;
exports.loggerStackTraceDebug = Si;
exports.memoize = cu;
exports.memoizeAsync = lu;
exports.moveSortWeight = Qu;
exports.noop = af;
exports.objectIsEmpty = $u;
exports.objectMap = Iu;
exports.objectMergeDisposable = Bu;
exports.parseArgs = lf;
exports.parseBasicAuth = Wo;
exports.parseDate = Ic;
exports.parseLogLevel = Ke;
exports.parseOrderby = Kr;
exports.parseQuery = ic;
exports.pbcopy = pf;
exports.promisify = H;
exports.qid = qc;
exports.randomBoolean = Fs;
exports.randomFloat = Ps;
exports.randomInt = Ds;
exports.randomUint8Array = se;
exports.readText = Ff;
exports.regExpEscape = ac;
exports.regExpString = Fo;
exports.removeFolder = Uf;
exports.renderMessages = $e;
exports.roundDown = Hu;
exports.roundHalfAwayFromZero = Wu;
exports.roundHalfDown = qu;
exports.roundHalfEven = Ju;
exports.roundHalfOdd = zu;
exports.roundHalfTowardsZero = Zu;
exports.roundHalfUp = Gu;
exports.roundUp = Vu;
exports.seededRandom = Is;
exports.setUuidDefaultEncoding = zc;
exports.setupEnv = Tf;
exports.setupWebCrypto = mf;
exports.size = Un;
exports.sleep = ja;
exports.sortedItems = Ao;
exports.sortedOrderby = Os;
exports.startSortWeight = Bn;
exports.stringToBoolean = ga;
exports.stringToFloat = ya;
exports.stringToInteger = ma;
exports.stringToPath = ti;
exports.stringToUInt8Array = Ht;
exports.suid = Vc;
exports.suidBytes = Hn;
exports.suidBytesDate = Ho;
exports.suidDate = Hc;
exports.sum = Zr;
exports.throttle = Il;
exports.timeout = Va;
exports.toBase64 = fe;
exports.toBase64Url = Xi;
exports.toBool = wa;
exports.toCamelCase = xn;
exports.toCapitalize = oo;
exports.toCapitalizeWords = la;
exports.toFloat = ha;
exports.toHex = zt;
exports.toHumanReadableFilePath = Cf;
exports.toHumanReadableUrl = Co;
exports.toInt = xa;
exports.toPath = Rt;
exports.toString = ba;
exports.toUint8Array = E;
exports.toValidFilename = kn;
exports.today = Ja;
exports.tryTimeout = En;
exports.uname = _;
exports.unescapeHTML = Uu;
exports.useAsyncMutex = Cc;
exports.useBase = q;
exports.useDefer = xc;
exports.useDispose = he;
exports.useDisposer = hc;
exports.useEventListener = Tc;
exports.useExitHandler = nf;
exports.useInterval = wc;
exports.useLevelFilter = z;
exports.useMessageHub = al;
exports.useMutex = vc;
exports.useNamespaceFilter = j;
exports.usePool = Ul;
exports.usePubSub = dl;
exports.useRPC = ml;
exports.useRPCHub = yl;
exports.useSorted = tc;
exports.useTimeout = bc;
exports.uuid = Y;
exports.uuid32bit = Gc;
exports.uuidB32 = Io;
exports.uuidB62 = Ro;
exports.uuidBytes = Ct;
exports.uuidDecode = zn;
exports.uuidDecodeB32 = $o;
exports.uuidDecodeB62 = ko;
exports.uuidDecodeV4 = No;
exports.uuidEncode = Go;
exports.uuidEncodeB32 = Bo;
exports.uuidEncodeB62 = Mo;
exports.uuidEncodeV4 = jo;
exports.uuidIsValid = Wc;
exports.uuidv4 = _o;
exports.valueToBoolean = ue;
exports.valueToFloat = so;
exports.valueToInteger = io;
exports.valueToPath = ni;
exports.valueToString = xt;
exports.waitOn = Ga;
exports.walkSync = ir;
exports.walkSyncAsync = ur;
exports.writeText = Df;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map